/*
USB Serial to LCD for TWITTER SCROLLER

George Smart, M1GEO  27 Oct 2011
http://www.george-smart.co.uk
*/

#include <LCD4Bit_mod.h> 

//create object to control an LCD - number of lines in display=2
LCD4Bit_mod lcd = LCD4Bit_mod(2); 

char string[35];
int  character = 0;
int  stringpos = 0;
int  n = 0;

void setup() { 
  pinMode(13, OUTPUT);
  
  Serial.begin( 9600 );
  
  lcd.init();
  lcd.clear();
  lcd.printIn(" Twitter    LCD ");
  lcd.cursorTo(2, 0);
  lcd.printIn("  George Smart  ");
  Serial.println("Twitter LCD - George Smart");
  delay(1000);
  for (n=0;n<35;n++) {
    string[n] = ' ';
  }
  Serial.println("Ready...");
}

void loop()
{
  if (Serial.available()) {
    while (Serial.available() > 0) {
      character = Serial.read();
      if (character == '\r') {  // carridge return
        //lcd.clear();
        lcd.cursorTo(1, 0);
        for (n=0;((n<16)&&(n<stringpos));n++) {
          if ( (string[n] != '\r') && (string[n] != '\n') ) {
            lcd.print(string[n]);
          }
        }
        lcd.cursorTo(2, 0);
        for (n=16;((n<33)&&(n<stringpos));n++) {
          lcd.print(string[n]);
        }
        stringpos = 0;
      } else if (character == 8) { // backspace
        stringpos--;
        string[stringpos+1] = '\0';
      } else if (character == '\n') {
        for (n=stringpos;n<35;n++) {
          string[n] = ' ';
        }
        stringpos = 16;
        string[stringpos+1] = '\0';
      } else {
        string[stringpos] = character;
        string[stringpos+1] = '\0';
        stringpos++;
      }
    }
  }
}


