#!/usr/bin/perl

# George Smart, M1GEO
# M1GEO Arduino Twitter Scroller

use Device::SerialPort;
use Net::Twitter;
use Scalar::Util 'blessed';
use Time::HiRes qw( usleep ualarm gettimeofday tv_interval );

# MODIFY THESE - YOU NEED TO SET AN APP KEY ON YOUR TWITTER.
# --  SEE THE PERL NET::TWITTER MODULE!
$consumer_key		= "";
$consumer_secret	= "";
$token				= "";
$token_secret		= "";

#$PortName			= "/dev/ttyACM0";
$PortName			= "$ARGV[0]";

$ScrollSpeed		= "200000"; # uS
$UserTimeRadio		= 15;	# number between 1 and 140.

$PortObj = new Device::SerialPort ($PortName) || die "Can't open $PortName: $!\n";
$PortObj->baudrate(9600);
$PortObj->databits(8);
$PortObj->parity("none");
$PortObj->stopbits(1);
$PortObj->handshake("none");
$PortObj->write_settings || undef $PortObj;

@months 	= qw(January Febuary March April May June July August September October November December);
@weekDays 	= qw(Sunday Monday Tuesday Wednesday Thursday Friday Saturday Sunday);

sub GetTime {
	($second, $minute, $hour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings) = localtime();
	$year = 1900 + $yearOffset;
	$theTime = "$hour:$minute:$second on $weekDays[$dayOfWeek], $dayOfMonth $months[$month] $year";
	return $theTime;
}

sub LCDisplay {
	my $showUsername = 0;
	($un, $ct, $tw) = @_;
	$unt = substr($un, 0, 16);
	$unt = "\@$unt";
	@tst = split(' ', $ct);
	$tst = "Tweeted @tst[3]";
	for($i = 0; $i <= length($tw); $i++) {
		$mod = ($i % $UserTimeRadio);
		if ($mod == 0) {if ($showUsername > 0) {$showUsername = 0;} else {$showUsername = 1;}}
		if ($showUsername) {$topline = $unt;} else {$topline = $tst;}
		$twt = substr("$tw  ", $i, 16);
		#print ("$i/$mod/$showUsername ($tst): $twt\n");
		$PortObj->write("$topline\n$twt\r");
		#if ($i == 0) {usleep (6*$ScrollSpeed);}
		usleep ($ScrollSpeed);
	}
}

# As of 13-Aug-2010, Twitter requires OAuth for authenticated requests
my $nt = Net::Twitter->new(
	traits   => [qw/OAuth API::REST/],
	consumer_key        => $consumer_key,
	consumer_secret     => $consumer_secret,
	access_token        => $token,
	access_token_secret => $token_secret,
);

while (1!=0) {
	$curTime = GetTime();
	LCDisplay ("M1GEO Ticker", "               Updated at $curTime.");
	eval {
		my $statuses = $nt->friends_timeline();
		for my $status ( @$statuses ) {
			print "\@$status->{user}{screen_name}: $status->{text} ($status->{created_at})\n";
			LCDisplay ($status->{user}{screen_name}, $status->{created_at},  "                $status->{text}");
		}
	};
	
	if ( my $err = $@ ) {
		die $@ unless blessed $err && $err->isa('Net::Twitter::Error');

		warn "HTTP Response Code: ", $err->code, "\n",
		"HTTP Message......: ", $err->message, "\n",
		"Twitter error.....: ", $err->error, "\n";
	}
	

}

undef $PortObj;
